%invpendcinit.m

% Define the following variables using the variable already defined at the top of invpend.m
% Already defined: g  acceleration of gravity divided by the cheat
%                  Lpend = lenghth of the inverted pendulum (L in the handout)
%                  f  the pole of the first-order pre-filter
%                  a2=3*g/(2*Lpend)

% Enter your controller parameters here.
a = sqrt(a2);       	% a needs to be defined here
c = a/8;    % c needs to be defined here
b=3*f/(2*Lpend);
k = -27*g/(8*a*f);     % k needs to be defined here (k is the gain of the controller)
numc = k*[1 a+f a*f] % The numerator of your controller should be added here
denc = [1 c-a -a*c]	% The denominator of your controller should be added here
%
xrefm = 3;
dxrefmax = 0.25*dt;
sysc = tf(numc, denc);
[ac,bc,cc,dc]=ssdata(c2d(sysc,dt,'zoh'));
xc = [0;0];
xreff=0;
tmax = 60;
npoints = round(tmax/dt);
ts = zeros(npoints,1);

% Modify xcoms for the Tracking Controller section
xcoms=zeros(npoints,1);

xrefs = zeros(npoints,1);
ths = zeros(npoints,1);
xcarts = zeros(npoints,1);
ip=1;
sysf = tf([5],[1 5]);
sysol = series(series(sysp,sysf),sysc);
figure(2);
rlocus(sysol);
figure(3);
nyquist(sysol);
figure(4);
margin(sysol);
